﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Windows.Forms;

namespace HeuristicLab.Optimization.Networks.Views {
  public partial class EntitySelectorDialog : Form {
    public string Caption {
      get { return Text; }
      set {
        if (InvokeRequired)
          Invoke(new Action<string>(s => { Caption = s; }), value);
        else
          Text = value;
      }
    }
    public EntitySelector EntitySelector {
      get { return entitySelector; }
    }

    public EntitySelectorDialog() {
      InitializeComponent();
      okButton.Enabled = entitySelector.SelectedEntity != null;
    }
    protected virtual void EntitySelectorDialog_Load(object sender, EventArgs e) {
      this.entitySelector.EntitiesTreeView.DoubleClick += new System.EventHandler(EntitiesTreeView_DoubleClick);
    }
    protected virtual void EntitySelectorDialog_Shown(object sender, EventArgs e) {
      okButton.Enabled = entitySelector.SelectedEntity != null;
    }
    protected virtual void entitySelector_SelectedEntityChanged(object sender, EventArgs e) {
      okButton.Enabled = entitySelector.SelectedEntity != null;
    }
    protected virtual void EntitiesTreeView_DoubleClick(object sender, System.EventArgs e) {
      if (entitySelector.SelectedEntity != null) {
        DialogResult = DialogResult.OK;
        Close();
      }
    }
  }
}
