#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2014 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core.Views;
using HeuristicLab.MainForm;
using System.Windows.Forms;

namespace HeuristicLab.Optimization.Networks.Views {
  [View("Message View")]
  [Content(typeof(Message), true)]
  [Content(typeof(IMessage), false)]
  public partial class MessageView : ItemView {
    public new IMessage Content {
      get { return (IMessage)base.Content; }
      set { base.Content = value; }
    }

    public MessageView() {
      InitializeComponent();
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();
      messageValueCollectionView.Content = Content == null ? null : Content.Values;
    }

    protected override void SetEnabledStateOfControls() {
      base.SetEnabledStateOfControls();
      messageValueCollectionView.Enabled = Content != null;
    }
  }
}
